(*==================================================================================================
  Project : BiCoq3
  Module : bbfix.v
  Fixpoint constructs from the B-Book
  --------------------------------------------------------------------------------------------------
  IPA E. Jaeger - SGDN/DCSSI/SDS/LTI, UPMC/LIP6/SPI - St: Feb 2008, Md: Mar 2009
  ================================================================================================*)

Require Export bbset.

(* Generalised intersection and union ------------------------------------------------------------*)

Definition B_ginter(s u:Ε):=let i:=¡(⋇(s×u),0) in
                            let j:=¡(⋇(s×u),1) in {i∊s∣∂(i)∈s⋁∀(j∙∂(j)∈u⇒∂(i)∈∂(j))}.
Notation "'⋒(' s ',' u ')'" := (B_ginter s u).

Definition B_gunion(s u:Ε):=let i:=¡(⋇(s×u),0) in
                            let j:=¡(⋇(s×u),1) in {i∊s∣∂(i)∈s⋁∃(j∙∂(j)∈u⋀∂(i)∈∂(j))}.
Notation "'⋓(' s ',' u ')'" := (B_ginter s u).

(* Properties ------------------------------------------------------------------------------------*)


(*================================================================================================*)
